#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "common.h"
#include "robots.h"
#include "dbms.h"


ROBOT*	Robots=NULL;

int FreeRobots(INDEXER *Indexer){
ROBOT *r;
	LOCK_ROBOTS();
	if(!Robots){
		UNLOCK_ROBOTS();
		return(0);
	}
	r=Robots;
	while(r->hostinfo){
		free(r->hostinfo);
		free(r->path);
		r++;
	}
	free_it(Robots);
	UNLOCK_ROBOTS();
	return(0);
}
int FindRobots(INDEXER *Indexer,char *url){
ROBOT *r;
int i;
	LOCK_ROBOTS();
	if(Robots){
		r=Robots;i=0;
		while(r->hostinfo){
			if(strstr(url,r->hostinfo)&&strstr(url,r->path)){
				UNLOCK_ROBOTS();
				return(i);
			}
			i++;r++;
		}
	}
	UNLOCK_ROBOTS();
	return(-1);
}
int ParseRobots(INDEXER *Indexer,char *content,char *hostinfo){
	int myrule=0;
	char *s,*e,*lt;

	DeleteRobotsFromHost(Indexer,hostinfo);
	s=gettoken(content,"\r\n",&lt);
	while(s){
		if(*s=='#'){
		}else
		if(!(STRNCASECMP(s,"User-Agent"))){
			if(strstr(s,INDEXER_USER_AGENT))myrule=1;
			else
			if(strstr(s,"*"))myrule=1;
			else
				myrule=0;
		}else
		if((!(STRNCASECMP(s,"Disallow")))&&(myrule)){
			if((e=strchr(s+9,'#')))*e=0;
			e=s+9;SKIP(e," \t");s=e;
			SKIPN(e," \t");*e=0;
			if(*s){
				if(IND_ERROR==AddRobotsToHost(Indexer,hostinfo,s))
					return(IND_ERROR);
			}
		}
		s=gettoken(NULL,"\n\r",&lt);
	}
	return(IND_OK);
}
